﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Catalyst.ComponentModel.DataAnnotations
{
    /// <summary>
    /// The type of filter to perform.
    /// </summary>
    public enum FilterControlMode
    {
        /// <summary>
        /// Returns true if the parameter value is equal to the property
        /// </summary>
        Equals, 
        /// <summary>
        /// Applies to Strings only.  Returns true if the property contains the string in the parameter value
        /// </summary>
        Contains,
        /// <summary>
        /// Returns true if the value lies in between the bounds supplied by the parameter value
        /// </summary>
        Range,
        /// <summary>
        /// Returns true if any of the values provided by the parameter equal the suppled value
        /// </summary>
        MultiSelect
    }
}
