﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace Catalyst.Web.DynamicData
{

    /// <summary>
    /// OrExpressionParameter evalutes a boolean OR operation against all parameters defined in the Parameters property.
    /// </summary>
    public class OrExpressionParameter : CompositeExpressionParameterBase
    {
        protected override Expression BuildBody(List<LambdaExpression> lambdas)
        {
            Expression root = lambdas[0].Body;
            for (int i = 1; i < lambdas.Count; i++)
            {
                root = Expression.MakeBinary(ExpressionType.Or, root, lambdas[i].Body);
            }
            return root;
        }
    }
}
