﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using Catalyst.ComponentModel.DataAnnotations;

namespace AdventureWorks.BusinessObjects
{
    [MetadataType(typeof(ProductMetadata))]
    public partial class Product
    {
        private interface ProductMetadata
        {
            [Filter(FilterMode = FilterControlMode.Contains)]
            string Name { get; set; }

            [Filter(FilterMode = FilterControlMode.Contains)]
            string ProductNumber { get; set; }

            [Filter(FilterMode = FilterControlMode.Contains)]
            string Color { get; set; }

            [Filter(FilterMode = FilterControlMode.Range)]
            decimal ListPrice { get; set; }

            [ScaffoldColumn(false)]
            Guid rowguid { get; set; }

            [ScaffoldColumn(false)]
            DateTime ModifiedDate { get; set; }
        }
    }
}
